Mention the EEXIST fix.
[rsync.git] / compat.c
index 57563b0bf21235c150c8c11e55e0424f4e7c461f..be0bf473cb5e425682217ce3f1fb1967fccc1f0a 100644 (file)
--- a/compat.c
+++ b/compat.c
@@ -30,20 +30,20 @@ int remote_protocol = 0;
 extern int verbose;
 extern int am_server;
 extern int am_sender;
+extern int inplace;
+extern int fuzzy_basis;
 extern int read_batch;
 extern int checksum_seed;
+extern int basis_dir_cnt;
 extern int protocol_version;
+extern char *dest_option;
 
 void setup_protocol(int f_out,int f_in)
 {
        if (remote_protocol == 0) {
-               if (am_server) {
-                       remote_protocol = read_int(f_in);
+               if (!read_batch)
                        write_int(f_out, protocol_version);
-               } else {
-                       write_int(f_out, protocol_version);
-                       remote_protocol = read_int(f_in);
-               }
+               remote_protocol = read_int(f_in);
                if (protocol_version > remote_protocol)
                        protocol_version = remote_protocol;
        }
@@ -59,7 +59,7 @@ void setup_protocol(int f_out,int f_in)
        }
        if (remote_protocol < MIN_PROTOCOL_VERSION
         || remote_protocol > MAX_PROTOCOL_VERSION) {
-               rprintf(FERROR,"protocol version mismatch - is your shell clean?\n");
+               rprintf(FERROR,"protocol version mismatch -- is your shell clean?\n");
                rprintf(FERROR,"(see the rsync man page for an explanation)\n");
                exit_cleanup(RERR_PROTOCOL);
        }
@@ -78,6 +78,27 @@ void setup_protocol(int f_out,int f_in)
                exit_cleanup(RERR_PROTOCOL);
        }
 
+       if (fuzzy_basis && protocol_version < 29) {
+               rprintf(FERROR,
+                       "--fuzzy requires protocol 29 or higher (negotiated %d).\n",
+                       protocol_version);
+               exit_cleanup(RERR_PROTOCOL);
+       }
+
+       if (basis_dir_cnt && inplace && protocol_version < 29) {
+               rprintf(FERROR,
+                       "%s with --inplace requires protocol 29 or higher (negotiated %d).\n",
+                       dest_option, protocol_version);
+               exit_cleanup(RERR_PROTOCOL);
+       }
+
+       if (basis_dir_cnt > 1 && protocol_version < 29) {
+               rprintf(FERROR,
+                       "Multiple %s options requires protocol 29 or higher (negotiated %d).\n",
+                       dest_option, protocol_version);
+               exit_cleanup(RERR_PROTOCOL);
+       }
+
        if (am_server) {
                if (!checksum_seed)
                        checksum_seed = time(NULL);